//+------------------------------------------------------------------+
//|                                         ASCTrend1sig_noSound.mq4 |
//|                                        Ramdass - Conversion only |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

//---- input parameters
extern int  RISK      = 7;
extern int  CountBars = 320;
bool   UseSound      = False;         //   
string NameFileSound = "expert.wav"; //   
datetime tpre=0, barspre=0;
int ntm = 25;
//---- buffers
double val1[];
double val2[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit(void){
  //int dt = StrToTime("2010.01.07");
  //Comment(dt);
  IndicatorBuffers(2);
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexArrow(0, 234);
  SetIndexStyle(1, DRAW_ARROW);
  SetIndexArrow(1, 233);
  SetIndexBuffer(0, val1);
  SetIndexBuffer(1, val2);
}

//+------------------------------------------------------------------+
//| ASCTrend1sig                                                     |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]){
  /*static int n=0, m;
  if (CountBars < 22)
  {
      m = (n / 7) % 2;
      val1[1] = m;
  	   if (m == 0) val2[1] = (n / 5) % 2;
  	   n++;
      return;
  }*/
  if (Bars != barspre) {
    barspre = Bars;
    tpre = Time[0];
  }
  else {
    datetime dt = time[0];
    if (dt - tpre < ntm) return 0;
    tpre = dt;
  }
  SetIndexDrawBegin(0, Bars-CountBars+11+1);
  SetIndexDrawBegin(1, Bars-CountBars+11+1);

  int i,shift,counted_bars=IndicatorCounted();
  int Counter,i1,value10,value11;
  double x1,x2;
  double value2,value3;
  double TrueCount,Range,AvgRange,MRO1,MRO2;
  double Table_value2[10000];
   
  value10=3+RISK*2;
  x1=67+RISK;
  x2=33-RISK;
  value11=value10;

  if(Bars<=11+1) return 0;
  //---- initial zero
  if (counted_bars<11+1) {
    for(i=1; i<=0; i++) val1[CountBars-i]=0.0;
    for(i=1; i<=0; i++) val2[CountBars-i]=0.0;
  }
  //----
  shift=CountBars-11-1;
  while (shift>=0) {
    Counter=shift;
  	Range=0.0;
  	AvgRange=0.0;
  	for (Counter=shift; Counter<=shift+9; Counter++) AvgRange+=high[Counter]-low[Counter];
  	Range=AvgRange/10;
  	Counter=shift;
  	TrueCount=0;
  	while (Counter<shift+9 && TrueCount<1) {
  	  if (MathAbs(open[Counter]-close[Counter+1])>=Range*2.0) TrueCount=TrueCount+1;
  		Counter=Counter+1;
		}
  	if (TrueCount>=1) MRO1=Counter;
  	else MRO1=-1;
  	Counter=shift;
  	TrueCount=0;
  	while (Counter<shift+6 && TrueCount<1) {
  	  if (MathAbs(close[Counter+3]-close[Counter])>=Range*4.6) TrueCount=TrueCount+1;
  		Counter=Counter+1;
		}
  	if (TrueCount>=1) MRO2=Counter;
  	else MRO2=-1;
  	if (MRO1>-1) value11=3; else value11=value10;
  	if (MRO2>-1) value11=4; else value11=value10;
  	value2=100-MathAbs(iWPR(NULL,0,value11,shift)); // PercentR(value11=9)
  	Table_value2[shift]=value2;
  	val1[shift]=0;
  	val2[shift]=0;
  	value3=0;
  	if (value2<x2) {
    	i1=1;
  		while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1) i1++;
  		if (Table_value2[shift+i1]>x1) {
  			value3=high[shift]+Range*0.5;
  			val1[shift]=value3;
        if (UseSound) PlaySound(NameFileSound);
			} 
		}
  	if (value2>x1) {
    	i1=1;
  		while (Table_value2[shift+i1]>=x2 && Table_value2[shift+i1]<=x1) i1++;
  		if (Table_value2[shift+i1]<x2) {
  			value3=low[shift]-Range*0.7;
  			val2[shift]=value3;
        if (UseSound) PlaySound(NameFileSound);
			}
		}
    shift--;
  }
  return 0;
}
//+------------------------------------------------------------------+

